import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { AppAuthGuard } from './guards/auth.guard';
import { AppMessengerResolver } from './resolvers/messenger.resolver';

const routes: Routes = [
  { path: '', redirectTo: '/messenger', pathMatch: 'full' },
  {
    path: 'messenger',
    loadChildren:
      './pages/messenger/messenger.page.module#AppMessengerPageModule',
    canActivate: [AppAuthGuard],
    resolve: {
      protocol: AppMessengerResolver
    }
  },
  {
    path: 'account',
    loadChildren: './pages/account/account.page.module#AppAccountPageModule'
  }
];

@NgModule({
  imports: [RouterModule.forRoot(routes, { enableTracing: false })],
  exports: [RouterModule]
})
export class AppRoutingModule {}
