import { Type } from '@angular/core';
import { Action, combineReducers, Selector, createSelector } from '@ngrx/store';

import * as SyncStore from './sync';

export interface State {
  sync: SyncStore.State;
}

export const effects: Type<any>[] = [SyncStore.Effects];

export function reducers(state: State | undefined, action: Action) {
  return combineReducers({
    sync: SyncStore.reducer
  })(state, action);
}

export function selectors<S>(selector: Selector<any, State>) {
  return {
    SyncSelector: SyncStore.selectors(
      createSelector(
        selector,
        (state: State) => state.sync
      )
    )
  };
}
