import { createAction, props } from '@ngrx/store';
import {
  BuddyRequest,
  BuddyResponse,
  BuddyDetailData,
  GroupRequest,
  GroupDetailData,
  GroupResponse
} from '@ucap-webmessenger/protocol-sync';

export const buddy2 = createAction(
  '[Messenger::Sync] Buddy2',
  props<BuddyRequest>()
);

export const buddy2Data = createAction(
  '[Messenger::Sync] Buddy2 Data',
  props<{ data: BuddyDetailData }>()
);

export const buddy2Success = createAction(
  '[Messenger::Sync] Buddy2 Success',
  props<{ res: BuddyResponse }>()
);

export const buddy2Failure = createAction(
  '[Messenger::Sync] Buddy2 Failure',
  props<{ error: any }>()
);

export const group2 = createAction(
  '[Messenger::Sync] Group2',
  props<GroupRequest>()
);

export const group2Data = createAction(
  '[Messenger::Sync] Group2 Data',
  props<{ data: GroupDetailData }>()
);

export const group2Success = createAction(
  '[Messenger::Sync] Group2 Success',
  props<{ res: GroupResponse }>()
);

export const group2Failure = createAction(
  '[Messenger::Sync] Group2 Failure',
  props<{ error: any }>()
);
