import { Injectable } from '@angular/core';

import { Actions, ofType, createEffect } from '@ngrx/effects';

import { of } from 'rxjs';
import { catchError, exhaustMap, map, tap } from 'rxjs/operators';

import { regViewSuccess, regViewFailure } from './actions';
import { initSettings } from '../init';
import { OptionProtocolService } from '@ucap-webmessenger/protocol-option';

@Injectable()
export class Effects {
  initSettings$ = createEffect(() =>
    this.actions$.pipe(
      ofType(initSettings),
      exhaustMap(() =>
        this.optionProtocolService.regView({}).pipe(
          map(res => regViewSuccess({ res })),
          catchError(error => of(regViewFailure({ error })))
        )
      )
    )
  );

  constructor(
    private actions$: Actions,
    private optionProtocolService: OptionProtocolService
  ) {}
}
